<?php
/*****************************************************************************
 * FeaturedThumbnailManager.php
 * Contains the featured thumbnail manager template.
 *
 * Kabuki CMS (C) 2013-2021, Aaron van Geffen
 *****************************************************************************/

class FeaturedThumbnailManager extends SubTemplate
{
	private $iterator;
	private $currentThumbnailId;

	public function __construct(AssetIterator $iterator, $currentThumbnailId)
	{
		$this->iterator = $iterator;
		$this->currentThumbnailId = $currentThumbnailId;
	}

	protected function html_content()
	{
		echo '
		<form action="" method="post">
			<button class="btn btn-primary float-end" type="submit" name="changeThumbnail">Save thumbnail selection</button>
			<h2>Select thumbnail</h2>
			<ul id="featuredThumbnail">';

		foreach ($this->iterator as $asset)
		{
			$image = $asset->getImage();
			echo '
				<li>
					<input class="form-check-input" type="radio" name="featuredThumbnail" value="', $image->getId(), '"',
					$this->currentThumbnailId == $image->getId() ? ' checked' : '', '>
					<img src="', $image->getThumbnailUrl(150, 100, 'top'), '" alt="" title="', $image->getTitle(), '" onclick="this.parentNode.children[0].checked = true">
				</li>';
		}

		echo '
				</ul>
				<input type="hidden" name="', Session::getSessionTokenKey(), '" value="', Session::getSessionToken(), '">
			</form>';
	}
}
